t4016-*.sh: Skip all tests rather than each test
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
3c8f12c9
JH
37# Test the binaries we have just built. The tests are kept in
38# t/ subdirectory and are run in 'trash directory' subdirectory.
39if test -z "$TEST_DIRECTORY"
40then
41 # We allow tests to override this, in case they want to run tests
42 # outside of t/, e.g. for running tests on the test library
43 # itself.
44 TEST_DIRECTORY=$(pwd)
45fi
46if test -z "$TEST_OUTPUT_DIRECTORY"
47then
48 # Similarly, override this to store the test-results subdir
49 # elsewhere
50 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
51fi
52GIT_BUILD_DIR="$TEST_DIRECTORY"/..
53
54. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
55export PERL_PATH SHELL_PATH
56
e1970ce4
JH
57# For repeatability, reset the environment to known value.
58LANG=C
899460f3 59LC_ALL=C
d9bdd39e 60PAGER=cat
e1970ce4 61TZ=UTC
c2116a17
JH
62TERM=dumb
63export LANG LC_ALL PAGER TERM TZ
8ff99e74 64EDITOR=:
661bfd13
SL
65# A call to "unset" with no arguments causes at least Solaris 10
66# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
67# deriving from the command substitution clustered with the other
68# ones.
3c8f12c9 69unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 70 my @env = keys %ENV;
730477f1
JL
71 my $ok = join("|", qw(
72 TRACE
73 DEBUG
74 USE_LOOKUP
75 TEST
76 .*_TEST
77 PROVE
78 VALGRIND
342e9ef2 79 PERF_AGGREGATING_LATER
730477f1
JL
80 ));
81 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
82 print join("\n", @vars);
83')
5adf84eb 84unset XDG_CONFIG_HOME
29e55cd5
JH
85GIT_AUTHOR_EMAIL=author@example.com
86GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
87GIT_COMMITTER_EMAIL=committer@example.com
88GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 89GIT_MERGE_VERBOSITY=5
f8246281
JH
90GIT_MERGE_AUTOEDIT=no
91export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
92export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
93export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 94export EDITOR
e1970ce4 95
886a3907
JH
96# Protect ourselves from common misconfiguration to export
97# CDPATH into the environment
98unset CDPATH
99
5565f47c
BW
100unset GREP_OPTIONS
101
3d5c0cc9 102case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
103 1|2|true)
104 echo "* warning: Some tests will not work if GIT_TRACE" \
105 "is set as to trace on STDERR ! *"
106 echo "* warning: Please set GIT_TRACE to something" \
107 "other than 1, 2 or true ! *"
108 ;;
109esac
110
cd3c095c
JH
111# Convenience
112#
113# A regexp to match 5 and 40 hexdigits
114_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
115_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
116
3749fde5
JH
117# Zero SHA-1
118_z40=0000000000000000000000000000000000000000
119
3f4ab627
JH
120# Line feed
121LF='
122'
123
342e9ef2
TR
124export _x05 _x40 _z40 LF
125
e1970ce4
JH
126# Each test should start with something like this, after copyright notices:
127#
128# test_description='Description of this test...
129# This test checks if command xyzzy does the right thing...
130# '
131# . ./test-lib.sh
c2116a17
JH
132[ "x$ORIGINAL_TERM" != "xdumb" ] && (
133 TERM=$ORIGINAL_TERM &&
134 export TERM &&
135 [ -t 1 ] &&
136 tput bold >/dev/null 2>&1 &&
137 tput setaf 1 >/dev/null 2>&1 &&
138 tput sgr0 >/dev/null 2>&1
139 ) &&
55db1df0 140 color=t
e1970ce4 141
e1970ce4
JH
142while test "$#" -ne 0
143do
144 case "$1" in
145 -d|--d|--de|--deb|--debu|--debug)
146 debug=t; shift ;;
886856ab
JH
147 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
148 immediate=t; shift ;;
5e2c08c6 149 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 150 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 151 -h|--h|--he|--hel|--help)
570f3226 152 help=t; shift ;;
e1970ce4
JH
153 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
154 verbose=t; shift ;;
1ece1274 155 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
156 # Ignore --quiet under a TAP::Harness. Saying how many tests
157 # passed without the ok/not ok details is always an error.
158 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
159 --with-dashes)
160 with_dashes=t; shift ;;
55db1df0 161 --no-color)
faa4bc35 162 color=; shift ;;
4e1be63c 163 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 164 valgrind=t; verbose=t; shift ;;
44138559
JS
165 --tee)
166 shift ;; # was handled already
f423ef5f
JK
167 --root=*)
168 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
169 shift ;;
e1970ce4 170 *)
1f729dca 171 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
172 esac
173done
174
55db1df0
PH
175if test -n "$color"; then
176 say_color () {
c2116a17
JH
177 (
178 TERM=$ORIGINAL_TERM
179 export TERM
55db1df0
PH
180 case "$1" in
181 error) tput bold; tput setaf 1;; # bold red
182 skip) tput bold; tput setaf 2;; # bold green
183 pass) tput setaf 2;; # green
184 info) tput setaf 3;; # brown
1ece1274 185 *) test -n "$quiet" && return;;
55db1df0
PH
186 esac
187 shift
5099b99d 188 printf "%s" "$*"
55db1df0 189 tput sgr0
b8eecafd 190 echo
c2116a17 191 )
55db1df0
PH
192 }
193else
194 say_color() {
1ece1274 195 test -z "$1" && test -n "$quiet" && return
55db1df0 196 shift
5099b99d 197 echo "$*"
55db1df0
PH
198 }
199fi
200
201error () {
202 say_color error "error: $*"
6e7b5aaf 203 GIT_EXIT_OK=t
55db1df0
PH
204 exit 1
205}
206
207say () {
208 say_color info "$*"
209}
210
570f3226
MB
211test "${test_description}" != "" ||
212error "Test script did not set test_description."
213
214if test "$help" = "t"
215then
216 echo "$test_description"
217 exit 0
218fi
219
4d9d62fa 220exec 5>&1
781f76b1 221exec 6<&0
e1970ce4
JH
222if test "$verbose" = "t"
223then
224 exec 4>&2 3>&1
225else
226 exec 4>/dev/null 3>/dev/null
227fi
228
229test_failure=0
230test_count=0
41ac414e
JH
231test_fixed=0
232test_broken=0
2d84e9fb 233test_success=0
e1970ce4 234
d998bd4a
ÆAB
235test_external_has_tap=0
236
faa4bc35 237die () {
6e7b5aaf
CB
238 code=$?
239 if test -n "$GIT_EXIT_OK"
240 then
241 exit $code
242 else
243 echo >&5 "FATAL: Unexpected exit with code $code"
244 exit 1
245 fi
faa4bc35
CB
246}
247
6e7b5aaf 248GIT_EXIT_OK=
35641310 249trap 'die' EXIT
41184273 250
12a29b1a
TR
251# The user-facing functions are loaded from a separate file so that
252# test_perf subshells can have them too
3c8f12c9 253. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 254
886856ab
JH
255# You are not expected to call test_ok_ and test_failure_ directly, use
256# the text_expect_* functions instead.
257
258test_ok_ () {
d5d9de1b 259 test_success=$(($test_success + 1))
5099b99d 260 say_color "" "ok $test_count - $@"
e1970ce4
JH
261}
262
886856ab 263test_failure_ () {
d5d9de1b 264 test_failure=$(($test_failure + 1))
5099b99d 265 say_color error "not ok - $test_count $1"
bf0dd8a8 266 shift
5099b99d 267 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 268 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
269}
270
41ac414e 271test_known_broken_ok_ () {
41ac414e 272 test_fixed=$(($test_fixed+1))
5099b99d 273 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
274}
275
276test_known_broken_failure_ () {
41ac414e 277 test_broken=$(($test_broken+1))
5099b99d 278 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 279}
886856ab
JH
280
281test_debug () {
8e832ebc 282 test "$debug" = "" || eval "$1"
e1970ce4
JH
283}
284
a7c58f28
JN
285test_eval_ () {
286 # This is a separate function because some tests use
287 # "return" to end a test_expect_success block early.
781f76b1 288 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
289}
290
4d9d62fa 291test_run_ () {
b6b0afdc 292 test_cleanup=:
b586744a 293 expecting_failure=$2
a7c58f28 294 test_eval_ "$1"
b6b0afdc 295 eval_ret=$?
b586744a
JH
296
297 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
298 then
a7c58f28 299 test_eval_ "$test_cleanup"
b586744a 300 fi
57e1538a
ÆAB
301 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
302 echo ""
303 fi
aa0bcf96 304 return "$eval_ret"
4d9d62fa
PR
305}
306
04ece593 307test_skip () {
8586f98b 308 test_count=$(($test_count+1))
04ece593
JH
309 to_skip=
310 for skp in $GIT_SKIP_TESTS
311 do
8586f98b 312 case $this_test.$test_count in
04ece593
JH
313 $skp)
314 to_skip=t
47e67d47 315 break
04ece593
JH
316 esac
317 done
05236a5e
JN
318 if test -z "$to_skip" && test -n "$test_prereq" &&
319 ! test_have_prereq "$test_prereq"
a7bb3940
JS
320 then
321 to_skip=t
322 fi
04ece593
JH
323 case "$to_skip" in
324 t)
07431fc8 325 of_prereq=
05236a5e 326 if test "$missing_prereq" != "$test_prereq"
07431fc8 327 then
05236a5e 328 of_prereq=" of $test_prereq"
07431fc8
JN
329 fi
330
55db1df0 331 say_color skip >&3 "skipping test: $@"
07431fc8 332 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
333 : true
334 ;;
335 *)
336 false
337 ;;
338 esac
339}
340
342e9ef2
TR
341# stub; perf-lib overrides it
342test_at_end_hook_ () {
343 :
344}
345
e1970ce4 346test_done () {
6e7b5aaf 347 GIT_EXIT_OK=t
2d84e9fb 348
8ef1abe5 349 if test -z "$HARNESS_ACTIVE"; then
342e9ef2 350 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5
ÆAB
351 mkdir -p "$test_results_dir"
352 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
353
c54e6be7
ML
354 cat >>"$test_results_path" <<-EOF
355 total $test_count
356 success $test_success
357 fixed $test_fixed
358 broken $test_broken
359 failed $test_failure
360
361 EOF
8ef1abe5 362 fi
41ac414e
JH
363
364 if test "$test_fixed" != 0
365 then
5099b99d 366 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
367 fi
368 if test "$test_broken" != 0
369 then
5099b99d 370 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
371 msg="remaining $(($test_count-$test_broken)) test(s)"
372 else
373 msg="$test_count test(s)"
41ac414e 374 fi
e1970ce4 375 case "$test_failure" in
10b94e28 376 0)
5099b99d
ÆAB
377 # Maybe print SKIP message
378 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
379
d998bd4a
ÆAB
380 if test $test_external_has_tap -eq 0; then
381 say_color pass "# passed all $msg"
382 say "1..$test_count$skip_all"
383 fi
abc5d372
JS
384
385 test -d "$remove_trash" &&
386 cd "$(dirname "$remove_trash")" &&
387 rm -rf "$(basename "$remove_trash")"
388
342e9ef2
TR
389 test_at_end_hook_
390
e1970ce4
JH
391 exit 0 ;;
392
393 *)
d998bd4a
ÆAB
394 if test $test_external_has_tap -eq 0; then
395 say_color error "# failed $test_failure among $msg"
396 say "1..$test_count"
397 fi
5099b99d 398
e1970ce4
JH
399 exit 1 ;;
400
401 esac
402}
403
e4597aae 404if test -n "$valgrind"
4e1be63c 405then
4e1be63c
JS
406 make_symlink () {
407 test -h "$2" &&
408 test "$1" = "$(readlink "$2")" || {
409 # be super paranoid
410 if mkdir "$2".lock
411 then
412 rm -f "$2" &&
413 ln -s "$1" "$2" &&
414 rm -r "$2".lock
415 else
416 while test -d "$2".lock
417 do
418 say "Waiting for lock on $2."
419 sleep 1
420 done
421 fi
422 }
423 }
424
425 make_valgrind_symlink () {
36bfb0e5
JK
426 # handle only executables, unless they are shell libraries that
427 # need to be in the exec-path. We will just use "#!" as a
428 # guess for a shell-script, since we have no idea what the user
429 # may have configured as the shell path.
430 test -x "$1" ||
431 test "#!" = "$(head -c 2 <"$1")" ||
432 return;
4e1be63c
JS
433
434 base=$(basename "$1")
6cec5c68 435 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
436 # do not override scripts
437 if test -x "$symlink_target" &&
438 test ! -d "$symlink_target" &&
439 test "#!" != "$(head -c 2 < "$symlink_target")"
440 then
441 symlink_target=../valgrind.sh
442 fi
efd92ffd
JS
443 case "$base" in
444 *.sh|*.perl)
445 symlink_target=../unprocessed-script
446 esac
4e1be63c
JS
447 # create the link, or replace it if it is out of date
448 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
449 }
450
451 # override all git executables in TEST_DIRECTORY/..
452 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
453 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 454 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
455 do
456 make_valgrind_symlink $file
457 done
ee0d7bf9
TR
458 # special-case the mergetools loadables
459 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
460 OLDIFS=$IFS
461 IFS=:
462 for path in $PATH
463 do
464 ls "$path"/git-* 2> /dev/null |
465 while read file
466 do
467 make_valgrind_symlink "$file"
468 done
469 done
470 IFS=$OLDIFS
4e1be63c
JS
471 PATH=$GIT_VALGRIND/bin:$PATH
472 GIT_EXEC_PATH=$GIT_VALGRIND/bin
473 export GIT_VALGRIND
e4597aae
MO
474elif test -n "$GIT_TEST_INSTALLED" ; then
475 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
476 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 477 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
478 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
479else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 480 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
e4597aae
MO
481 if ! test -x "$git_bin_dir/git" ; then
482 if test -z "$with_dashes" ; then
483 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
484 fi
485 with_dashes=t
486 fi
487 PATH="$git_bin_dir:$PATH"
6cec5c68 488 GIT_EXEC_PATH=$GIT_BUILD_DIR
e4597aae 489 if test -n "$with_dashes" ; then
6cec5c68 490 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 491 fi
4e1be63c 492fi
6cec5c68 493GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 494unset GIT_CONFIG
8bfa6bd6 495GIT_CONFIG_NOSYSTEM=1
3c995beb 496GIT_ATTR_NOSYSTEM=1
8f323c00 497export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 498
5e87eae9
JH
499if test -z "$GIT_TEST_CMP"
500then
501 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
502 then
503 GIT_TEST_CMP="$DIFF -c"
504 else
505 GIT_TEST_CMP="$DIFF -u"
506 fi
507fi
508
6cec5c68 509GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 510export GITPERLLIB
6cec5c68 511test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
512 error "You haven't built things yet, have you?"
513}
e1970ce4 514
ac10a857 515if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 516then
6cec5c68 517 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 518 export GITPYTHONLIB
6cec5c68 519 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
520 error "You haven't built git_remote_helpers yet, have you?"
521 }
522fi
523
6cec5c68 524if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
56cf9806
EW
525 echo >&2 'You need to build test-chmtime:'
526 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
527 exit 1
528fi
529
e1970ce4 530# Test repository
abc5d372 531test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
532test -n "$root" && test="$root/$test"
533case "$test" in
534/*) TRASH_DIRECTORY="$test" ;;
342e9ef2 535 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$test" ;;
f423ef5f 536esac
91c8b825 537test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 538rm -fr "$test" || {
6e7b5aaf 539 GIT_EXIT_OK=t
8d14ac94
JH
540 echo >&5 "FATAL: Cannot prepare test area"
541 exit 1
542}
543
90cff968
AR
544HOME="$TRASH_DIRECTORY"
545export HOME
546
342e9ef2
TR
547if test -z "$TEST_NO_CREATE_REPO"; then
548 test_create_repo "$test"
549else
550 mkdir -p "$test"
551fi
1bd9c648
LW
552# Use -P to resolve symlinks in our working directory so that the cwd
553# in subprocesses like git equals our $PWD (for pathname comparisons).
554cd -P "$test" || exit 1
04ece593 555
d5d9de1b
JS
556this_test=${0##*/}
557this_test=${this_test%%-*}
04ece593
JH
558for skp in $GIT_SKIP_TESTS
559do
47e67d47
MG
560 case "$this_test" in
561 $skp)
55db1df0 562 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 563 skip_all="skip all tests in $this_test"
04ece593
JH
564 test_done
565 esac
566done
f17e9fbb 567
8648732e
BC
568# Provide an implementation of the 'yes' utility
569yes () {
570 if test $# = 0
571 then
572 y=y
573 else
574 y="$*"
575 fi
576
577 while echo "$y"
578 do
579 :
580 done
581}
582
f17e9fbb
JS
583# Fix some commands on Windows
584case $(uname -s) in
585*MINGW*)
586 # Windows has its own (incompatible) sort and find
587 sort () {
588 /usr/bin/sort "$@"
589 }
590 find () {
591 /usr/bin/find "$@"
592 }
5397ea31
JS
593 sum () {
594 md5sum "$@"
595 }
4114156a
JS
596 # git sees Windows-style pwd
597 pwd () {
598 builtin pwd -W
599 }
ee9fb68c 600 # no POSIX permissions
6fd1106a 601 # backslashes in pathspec are converted to '/'
fb9a2bea 602 # exec does not inherit the PID
a94114ad 603 test_set_prereq MINGW
a31d0665
RJ
604 test_set_prereq SED_STRIPS_CR
605 ;;
606*CYGWIN*)
607 test_set_prereq POSIXPERM
a31d0665
RJ
608 test_set_prereq EXECKEEPSPID
609 test_set_prereq NOT_MINGW
610 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
611 ;;
612*)
613 test_set_prereq POSIXPERM
6fd1106a 614 test_set_prereq BSLASHPSPEC
fb9a2bea 615 test_set_prereq EXECKEEPSPID
3ba9ba8f 616 test_set_prereq NOT_MINGW
f17e9fbb
JS
617 ;;
618esac
704a3143 619
b082687c 620( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 621test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 622test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 623test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 624test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 625
bb946bba 626# Can we rely on git's output in the C locale?
30955229
JN
627if test -n "$GETTEXT_POISON"
628then
629 GIT_GETTEXT_POISON=YesPlease
630 export GIT_GETTEXT_POISON
5e9637c6 631 test_set_prereq GETTEXT_POISON
30955229
JN
632else
633 test_set_prereq C_LOCALE_OUTPUT
634fi
bb946bba 635
cabdee2c
JH
636# Use this instead of test_cmp to compare files that contain expected and
637# actual output from git commands that can be translated. When running
638# under GETTEXT_POISON this pretends that the command produced expected
639# results.
640test_i18ncmp () {
641 test -n "$GETTEXT_POISON" || test_cmp "$@"
642}
643
127df8c6
JH
644# Use this instead of "grep expected-string actual" to see if the
645# output from a git command that can be translated either contains an
646# expected string, or does not contain an unwanted one. When running
647# under GETTEXT_POISON this pretends that the command produced expected
648# results.
649test_i18ngrep () {
650 if test -n "$GETTEXT_POISON"
651 then
652 : # pretend success
653 elif test "x!" = "x$1"
654 then
655 shift
656 ! grep "$@"
657 else
658 grep "$@"
659 fi
660}
661
704a3143
JS
662# test whether the filesystem supports symbolic links
663ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
664rm -f y
c91cfd19
ÆAB
665
666# When the tests are run as root, permission tests will report that
667# things are writable when they shouldn't be.
668test -w / || test_set_prereq SANITY